Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zagg.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zagg.F90	(revision 14275)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zagg.F90	(revision 14276)
@@ -75,12 +75,12 @@
                   ! Part I : Coagulation dependent on turbulence
                   ! The stickiness has been assumed to be 0.1
-                  zagg1 = 25.9  * zfact * trb(ji,jj,jk,jppoc) * trb(ji,jj,jk,jppoc)
-                  zagg2 = 4452. * zfact * trb(ji,jj,jk,jppoc) * trb(ji,jj,jk,jpgoc)
+                  zagg1 = 12.5  * zfact * trb(ji,jj,jk,jppoc) * trb(ji,jj,jk,jppoc)
+                  zagg2 = 169.7 * zfact * trb(ji,jj,jk,jppoc) * trb(ji,jj,jk,jpgoc)
 
                   ! Part II : Differential settling
                   ! Aggregation of small into large particles
                   ! The stickiness has been assumed to be 0.1
-                  zagg3 =  47.1 * xstep * trb(ji,jj,jk,jppoc) * trb(ji,jj,jk,jpgoc)
-                  zagg4 =  3.3  * xstep * trb(ji,jj,jk,jppoc) * trb(ji,jj,jk,jppoc)
+                  zagg3 =  8.63  * xstep * trb(ji,jj,jk,jppoc) * trb(ji,jj,jk,jppoc)
+                  zagg4 =  132.8 * xstep * trb(ji,jj,jk,jppoc) * trb(ji,jj,jk,jpgoc)
 
                   zagg   = zagg1 + zagg2 + zagg3 + zagg4
@@ -92,14 +92,13 @@
                   ! 3rd term is differential settling of DOC-POC
                   ! 1/3 of DOC is supposed to experience aggregation (HMW)
-                  zaggdoc  = ( ( 0.369 * 0.3 * trb(ji,jj,jk,jpdoc) + 102.4 * trb(ji,jj,jk,jppoc) ) * zfact       &
-                  &            + 2.4 * xstep * trb(ji,jj,jk,jppoc) ) * 0.3 * trb(ji,jj,jk,jpdoc)
+                  zaggdoc  = ( ( 12.0 * 0.3 * trb(ji,jj,jk,jpdoc) + 9.05 * trb(ji,jj,jk,jppoc) ) * zfact       &
+                  &            + 2.49 * xstep * trb(ji,jj,jk,jppoc) ) * 0.3 * trb(ji,jj,jk,jpdoc)
                   ! transfer of DOC to GOC : 
                   ! 1st term is shear aggregation
-                  ! 2nd term is differential settling 
-                  ! 1/3 of DOC is supposed to experience aggregation (HMW)
-                  zaggdoc2 = ( 3.53E3 * zfact + 0.1 * xstep ) * trb(ji,jj,jk,jpgoc) * 0.3 * trb(ji,jj,jk,jpdoc)
+                  ! 1/3 of DOC is supposed to experience aggregation (HMW)
+                  zaggdoc2 = ( 1.94 * zfact + 1.37 * xstep ) * trb(ji,jj,jk,jpgoc) * 0.3 * trb(ji,jj,jk,jpdoc)
                   ! tranfer of DOC to POC due to brownian motion
                   ! The temperature dependency has been omitted.
-                  zaggdoc3 =  114. * 0.3 * trb(ji,jj,jk,jpdoc) *xstep * 0.3 * trb(ji,jj,jk,jpdoc)
+                  zaggdoc3 =  ( 127.8 * 0.3 * trb(ji,jj,jk,jpdoc) + 725.7 * trb(ji,jj,jk,jppoc) ) * xstep * 0.3 * trb(ji,jj,jk,jpdoc)
 
                   !  Update the trends
@@ -150,6 +149,6 @@
                   ! 3rd term is differential settling of DOC-POC
                   ! 1/3 of DOC is supposed to experience aggregation (HMW)
-                  zaggtmp = ( ( 0.369 * 0.3 * trb(ji,jj,jk,jpdoc) + 102.4 * trb(ji,jj,jk,jppoc) ) * zfact       &
-                  &            + 2.4 * xstep * trb(ji,jj,jk,jppoc) )
+                  zaggtmp = ( ( 0.37 * 0.3 * trb(ji,jj,jk,jpdoc) + 20.5 * trb(ji,jj,jk,jppoc) ) * zfact       &
+                  &            + 0.15 * xstep * trb(ji,jj,jk,jppoc) )
                   zaggdoc  = zaggtmp * 0.3 * trb(ji,jj,jk,jpdoc)
                   zaggdon  = zaggtmp * 0.3 * trb(ji,jj,jk,jpdon)
@@ -160,5 +159,5 @@
                   ! 2nd term is differential settling 
                   ! 1/3 of DOC is supposed to experience aggregation (HMW)
-                  zaggtmp = ( 3.53E3 * zfact + 0.1 * xstep ) * trb(ji,jj,jk,jpgoc)
+                  zaggtmp = 655.4 * zfact * trb(ji,jj,jk,jpgoc)
                   zaggdoc2 = zaggtmp * 0.3 * trb(ji,jj,jk,jpdoc)
                   zaggdon2 = zaggtmp * 0.3 * trb(ji,jj,jk,jpdon)
@@ -167,5 +166,5 @@
                   ! tranfer of DOC to POC due to brownian motion
                   ! 1/3 of DOC is supposed to experience aggregation (HMW)
-                  zaggtmp = ( 114. * 0.3 * trb(ji,jj,jk,jpdoc) ) * xstep
+                  zaggtmp = ( 260.2 * 0.3 * trb(ji,jj,jk,jpdoc) +  418.5 * trb(ji,jj,jk,jppoc) ) * xstep
                   zaggdoc3 =  zaggtmp * 0.3 * trb(ji,jj,jk,jpdoc)
                   zaggdon3 =  zaggtmp * 0.3 * trb(ji,jj,jk,jpdon)
Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zbio.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zbio.F90	(revision 14275)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zbio.F90	(revision 14276)
@@ -110,8 +110,8 @@
 
       ! Update of the size of the different phytoplankton groups
-      sized(:,:,:) = sizeda(:,:,:)
-      sizen(:,:,:) = sizena(:,:,:)
+      sized(:,:,:) = MAX(1.0, sizeda(:,:,:) )
+      sizen(:,:,:) = MAX(1.0, sizena(:,:,:) )
       IF (ln_p5z) THEN
-         sizep(:,:,:) = sizepa(:,:,:)
+         sizep(:,:,:) = MAX(1.0, sizepa(:,:,:) )
       ENDIF
       !                                                             !
Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zfechem.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zfechem.F90	(revision 14275)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zfechem.F90	(revision 14276)
@@ -30,4 +30,5 @@
    REAL(wp), PUBLIC ::   ligand       !: ligand concentration in the ocean 
    REAL(wp), PUBLIC ::   kfep         !: rate constant for nanoparticle formation
+   REAL(wp), PUBLIC ::   scaveff      !: Fraction of scavenged iron that is considered as being subject to solubilization
 
    !!----------------------------------------------------------------------
@@ -50,12 +51,12 @@
       !
       INTEGER  ::   ji, jj, jk, jic, jn
-      REAL(wp) ::   zdep, zlam1a, zlam1b, zlamfac
-      REAL(wp) ::   zkeq, zfeequi, zfesatur, zfecoll, fe3sol, zligco
-      REAL(wp) ::   zdenom1, zscave, zaggdfea, zaggdfeb, zcoag, ztrc, zdust
-      REAL(wp) ::   zdenom2, ztfe, zhplus, zxlam, zaggliga, zaggligb
+      REAL(wp) ::   zlam1a, zlam1b
+      REAL(wp) ::   zkeq, zfesatur, zfecoll, fe3sol, zligco
+      REAL(wp) ::   zscave, zaggdfea, zaggdfeb, ztrc, zdust, zklight
+      REAL(wp) ::   ztfe, zhplus, zxlam, zaggliga, zaggligb
       REAL(wp) ::   zrfact2
       CHARACTER (len=25) :: charout
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zTL1, zFe3, ztotlig, precip, zFeL1
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zcoll3d, zscav3d, zlcoll3d
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zTL1, zFe3, ztotlig, precip, precipno3, zFeL1
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zcoll3d, zscav3d, zlcoll3d, zprecip3d
       !!---------------------------------------------------------------------
       !
@@ -66,12 +67,12 @@
 
       ! Total ligand concentration : Ligands can be chosen to be constant or variable
-      ! Parameterization from Tagliabue and Voelker (2011)
+      ! Parameterization from Pham and Ito (2018)
       ! -------------------------------------------------
       IF( ln_ligvar ) THEN
-         ztotlig(:,:,:) =  0.09 * trb(:,:,:,jpdoc) * 1E6 + ligand * 1E9
+         ztotlig(:,:,:) =  0.09 * 0.667 * trb(:,:,:,jpdoc) * 1E6 + ligand * 1E9 + MAX(0., chemo2(:,:,:) - trb(:,:,:,jpoxy) ) / 400.E-6
          ztotlig(:,:,:) =  MIN( ztotlig(:,:,:), 10. )
       ELSE
         IF( ln_ligand ) THEN  ;   ztotlig(:,:,:) = trb(:,:,:,jplgw) * 1E9
-        ELSE                  ;   ztotlig(:,:,:) = ligand * 1E9
+        ELSE                  ;   ztotlig(:,:,:) = ligand * 1E9 
         ENDIF
       ENDIF
@@ -79,5 +80,5 @@
       ! ------------------------------------------------------------
       !  from Aumont and Bopp (2006)
-      ! This model is based on one ligand and Fe' 
+      ! This model is based on one ligand, Fe2+ and Fe3+ 
       ! Chemistry is supposed to be fast enough to be at equilibrium
       ! ------------------------------------------------------------
@@ -87,17 +88,18 @@
                zTL1(ji,jj,jk)  = ztotlig(ji,jj,jk)
                zkeq            = fekeq(ji,jj,jk)
+               zklight         = 4.77E-7 * etot(ji,jj,jk) * 0.5 / 10**-6.3
                zfesatur        = zTL1(ji,jj,jk) * 1E-9
-               ztfe            = trb(ji,jj,jk,jpfer) 
+               ztfe            = (1.0 + zklight) * trb(ji,jj,jk,jpfer) 
                ! Fe' is the root of a 2nd order polynom
-               zFe3 (ji,jj,jk) = ( -( 1. + zfesatur * zkeq - zkeq * ztfe )               &
-                  &              + SQRT( ( 1. + zfesatur * zkeq - zkeq * ztfe )**2       &
+               zFe3 (ji,jj,jk) = ( -( 1. + zfesatur * zkeq + zklight + consfe3(ji,jj,jk)/10**-6.3 - zkeq * trb(ji,jj,jk,jpfer) )               &
+                  &              + SQRT( ( 1. + zfesatur * zkeq + zklight + consfe3(ji,jj,jk)/10**-6.3 - zkeq * trb(ji,jj,jk,jpfer) )**2       &
                   &              + 4. * ztfe * zkeq) ) / ( 2. * zkeq )
-               zFe3 (ji,jj,jk) = zFe3(ji,jj,jk) * 1E9
-               zFeL1(ji,jj,jk) = MAX( 0., trb(ji,jj,jk,jpfer) * 1E9 - zFe3(ji,jj,jk) )
+               zFeL1(ji,jj,jk) = MAX( 0., trb(ji,jj,jk,jpfer) - zFe3(ji,jj,jk) )
            END DO
          END DO
       END DO
-         !
-
+      !
+      plig(:,:,:) =  MAX( 0., ( zFeL1(:,:,:) / ( trb(:,:,:,jpfer) + rtrn ) ) )
+      !
       zdust = 0.         ! if no dust available
       DO jk = 1, jpkm1
@@ -113,32 +115,17 @@
                &         + fesol(ji,jj,jk,5) / zhplus )
                !
-               zfeequi = zFe3(ji,jj,jk) * 1E-9
-               zfecoll = 0.5 * zFeL1(ji,jj,jk) * 1E-9
+               zfecoll = 0.5 * zFeL1(ji,jj,jk)
                ! precipitation of Fe3+, creation of nanoparticles
-               precip(ji,jj,jk) = MAX( 0., ( zFe3(ji,jj,jk) * 1E-9 - fe3sol ) ) * kfep * xstep
+               precip(ji,jj,jk) = MAX( 0., ( zFe3(ji,jj,jk) - fe3sol ) ) * kfep * xstep * ( 1.0 - nitrfac(ji,jj,jk) ) 
+               ! Precipitation of Fe2+ due to oxidation by NO3 (Croot et al., 2019)
+               ! This occurs in anoxic waters only
+               precipno3(ji,jj,jk) = 2.0 * 130.0 * trb(ji,jj,jk,jpno3) * nitrfac(ji,jj,jk) * xstep * zFe3(ji,jj,jk)
                !
                ztrc   = ( trb(ji,jj,jk,jppoc) + trb(ji,jj,jk,jpgoc) + trb(ji,jj,jk,jpcal) + trb(ji,jj,jk,jpgsi) ) * 1.e6 
+               ztrc = MAX( rtrn, ztrc )
                IF( ln_dust )  zdust  = dust(ji,jj) / ( wdust / rday ) * tmask(ji,jj,jk)
-               IF (ln_ligand) THEN
-                  zxlam  = xlam1 * MAX( 1.E-3, EXP(-2 * etot(ji,jj,jk) / 10. ) * (1. - EXP(-2 * trb(ji,jj,jk,jpoxy) / 100.E-6 ) ))
-               ELSE
-                  zxlam  = xlam1 * 1.0
-               ENDIF
-               zlam1b = 3.e-5 + xlamdust * zdust + zxlam * ztrc
-               zscave = zfeequi * zlam1b * xstep
-
-               ! Compute the different ratios for scavenging of iron
-               ! to later allocate scavenged iron to the different organic pools
-               ! ---------------------------------------------------------
-               zdenom1 = zxlam * trb(ji,jj,jk,jppoc) / zlam1b
-               zdenom2 = zxlam * trb(ji,jj,jk,jpgoc) / zlam1b
-
-               ! Increased scavenging for very high iron concentrations found near the coasts 
-               ! due to increased lithogenic particles and let say it is unknown processes (precipitation, ...)
-               !  -----------------------------------------------------------
-               zlamfac = MAX( 0.e0, ( gphit(ji,jj) + 55.) / 30. )
-               zlamfac = MIN( 1.  , zlamfac )
-               zdep    = MIN( 1., 1000. / gdept_n(ji,jj,jk) )
-               zcoag   = 1E-4 * ( 1. - zlamfac ) * zdep * xstep * trb(ji,jj,jk,jpfer)
+               zxlam  = MAX( 1.E-3, (1. - EXP(-2 * trb(ji,jj,jk,jpoxy) / 100.E-6 ) ))
+               zlam1b = 3.e-5 + ( xlamdust * zdust + xlam1 * ztrc ) * zxlam
+               zscave = zFe3(ji,jj,jk) * zlam1b * xstep
 
                ! Compute the coagulation of colloidal iron. This parameterization 
@@ -146,17 +133,32 @@
                ! It requires certainly some more work as it is very poorly constrained.
                ! ----------------------------------------------------------------
-               zlam1a   = ( 0.369  * 0.3 * trb(ji,jj,jk,jpdoc) + 102.4  * trb(ji,jj,jk,jppoc) ) * xdiss(ji,jj,jk)    &
-                   &    + ( 114.   * 0.3 * trb(ji,jj,jk,jpdoc) )
+               zlam1a   = ( 12.0  * 0.3 * trb(ji,jj,jk,jpdoc) + 9.05  * trb(ji,jj,jk,jppoc) ) * xdiss(ji,jj,jk)    &
+                   &    + ( 2.49  * trb(ji,jj,jk,jppoc) )     &
+                   &    + ( 127.8 * 0.3 * trb(ji,jj,jk,jpdoc) + 725.7 * trb(ji,jj,jk,jppoc) )
                zaggdfea = zlam1a * xstep * zfecoll
                !
-               zlam1b   = 3.53E3 * trb(ji,jj,jk,jpgoc) * xdiss(ji,jj,jk)
+               zlam1b   = ( 1.94 * xdiss(ji,jj,jk) + 1.37 ) * trb(ji,jj,jk,jpgoc)
                zaggdfeb = zlam1b * xstep * zfecoll
                !
                tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) - zscave - zaggdfea - zaggdfeb &
-               &                     - zcoag - precip(ji,jj,jk)
-               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + zscave * zdenom1 + zaggdfea
-               tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + zscave * zdenom2 + zaggdfeb
-               zscav3d(ji,jj,jk)   = zscave
+               &                     - precip(ji,jj,jk) - precipno3(ji,jj,jk)
+               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + zscave * scaveff * trb(ji,jj,jk,jppoc) / ztrc
+               tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + zscave * scaveff * trb(ji,jj,jk,jpgoc) / ztrc
+
+               ! Precipitated iron is supposed to be permanently lost.
+               ! Scavenged iron is supposed to be released back to seawater
+               ! when POM is solubilized. This is highly uncertain as probably
+               ! a significant part of it may be rescavenged back onto 
+               ! the particles. An efficiency factor is applied that is read
+               ! in the namelist. 
+               ! See for instance Tagliabue et al. (2019).
+               ! Aggregated FeL is considered as biogenic Fe as it 
+               ! probably remains  complexed when the particle is solubilized.
+               ! -------------------------------------------------------------
+               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + zaggdfea
+               tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + zaggdfeb
+               zscav3d(ji,jj,jk)   = zscave 
                zcoll3d(ji,jj,jk)   = zaggdfea + zaggdfeb
+               zprecip3d(ji,jj,jk) = precip(ji,jj,jk) + precipno3(ji,jj,jk)
                !
             END DO
@@ -175,14 +177,15 @@
 
                   ! Coagulation of ligands due to various processes (Brownian, shear, diff. sedimentation
-                  ! Coefficients are taken from the p4zagg
+                  ! Coefficients are taken from p4zagg
                   ! -------------------------------------------------------------------------------------
-                  zlam1a   = ( 0.369  * 0.3 * trb(ji,jj,jk,jpdoc) + 102.4  * trb(ji,jj,jk,jppoc) ) * xdiss(ji,jj,jk)    &
-                      &    + ( 114.   * 0.3 * trb(ji,jj,jk,jpdoc) )
+                  zlam1a   = ( 12.0  * 0.3 * trb(ji,jj,jk,jpdoc) + 9.05  * trb(ji,jj,jk,jppoc) ) * xdiss(ji,jj,jk)    &
+                      &    + ( 2.49  * trb(ji,jj,jk,jppoc) )     &
+                      &    + ( 127.8 * 0.3 * trb(ji,jj,jk,jpdoc) + 725.7 * trb(ji,jj,jk,jppoc) )
                   !
-                  zlam1b   = 3.53E3 *   trb(ji,jj,jk,jpgoc) * xdiss(ji,jj,jk)
-
+                  zlam1b   = ( 1.94 * xdiss(ji,jj,jk) + 1.37 ) * trb(ji,jj,jk,jpgoc)
                   ! 50% of the ligands are supposed to be in the colloidal size fraction
-                  zligco   = 0.5 * trn(ji,jj,jk,jplgw)
-                  zaggliga = zlam1a * xstep * zligco
+                  ! as for FeL
+                  zligco   = 0.5 * trb(ji,jj,jk,jplgw)
+                  zaggliga = zlam1a * xstep * zligco 
                   zaggligb = zlam1b * xstep * zligco
                   tra(ji,jj,jk,jplgw) = tra(ji,jj,jk,jplgw) - zaggliga - zaggligb
@@ -191,6 +194,4 @@
             END DO
          END DO
-         !
-         plig(:,:,:) =  MAX( 0., ( ( zFeL1(:,:,:) * 1E-9 ) / ( trb(:,:,:,jpfer) +rtrn ) ) )
          !
       ENDIF
@@ -206,4 +207,5 @@
          IF( iom_use("FESCAV") )  CALL iom_put("FESCAV" , zscav3d(:,:,:)  * 1e9 * tmask(:,:,:) * zrfact2 )
          IF( iom_use("FECOLL") )  CALL iom_put("FECOLL" , zcoll3d(:,:,:)  * 1e9 * tmask(:,:,:) * zrfact2 )
+         IF( iom_use("FEPREC") )  CALL iom_put("FEPREC" , zprecip3d(:,:,:)  * 1e9 * tmask(:,:,:) * zrfact2 )
          IF( iom_use("LGWCOLL"))  CALL iom_put("LGWCOLL", zlcoll3d(:,:,:) * 1e9 * tmask(:,:,:) * zrfact2 )
       ENDIF
@@ -234,5 +236,5 @@
       INTEGER ::   ios   ! Local integer 
       !!
-      NAMELIST/nampisfer/ ln_ligvar, xlam1, xlamdust, ligand, kfep 
+      NAMELIST/nampisfer/ ln_ligvar, xlam1, xlamdust, ligand, kfep, scaveff 
       !!----------------------------------------------------------------------
       !
@@ -258,4 +260,5 @@
          WRITE(numout,*) '      ligand concentration in the ocean         ligand       =', ligand
          WRITE(numout,*) '      rate constant for nanoparticle formation  kfep         =', kfep
+         WRITE(numout,*) '      Scavenged iron that is added to POFe      scaveff      =', scaveff
       ENDIF
       ! 
Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zflx.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zflx.F90	(revision 14275)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zflx.F90	(revision 14276)
@@ -359,5 +359,5 @@
       IF( ln_presatm ) THEN
          CALL fld_read( kt, 1, sf_patm )               !* input Patm provided at kt + 1/2
-         patm(:,:) = sf_patm(1)%fnow(:,:,1)                        ! atmospheric pressure
+         patm(:,:) = sf_patm(1)%fnow(:,:,1)/101325.0     ! atmospheric pressure
       ENDIF
       !
Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zint.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zint.F90	(revision 14275)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zint.F90	(revision 14276)
@@ -36,5 +36,5 @@
       !
       INTEGER  :: ji, jj                 ! dummy loop indices
-      REAL(wp) :: zvar                   ! local variable
+      REAL(wp) :: zrum, zcodel, zargu, zvar
       !!---------------------------------------------------------------------
       !
@@ -44,9 +44,7 @@
       ! -------------------------------------------
       ! Generic temperature dependence (Eppley, 1972)
-      tgfunc (:,:,:) = EXP( 0.063913 * tsn(:,:,:,jp_tem) )
+      tgfunc (:,:,:) = EXP( 0.0631 * tsn(:,:,:,jp_tem) )
       ! Temperature dependence of mesozooplankton (Buitenhuis et al. (2005))
-      tgfunc2(:,:,:) = EXP( 0.07608  * tsn(:,:,:,jp_tem) )
-      ! Temperature dependence of picophytoplankton (Stawiarsky et al., 2016)
-      tgfunc3(:,:,:) = EXP( 0.0825   * tsn(:,:,:,jp_tem) )
+      tgfunc2(:,:,:) = EXP( 0.0761  * tsn(:,:,:,jp_tem) )
 
       ! Computation of the silicon dependant half saturation  constant for silica uptake
@@ -69,4 +67,19 @@
       ENDIF
       !
+      ! compute the day length depending on latitude and the day
+      ! Astronomical parameterization taken from HAMOCC3
+      zrum = REAL( nday_year - 80, wp ) / REAL( nyear_len(1), wp )
+      zcodel = ASIN(  SIN( zrum * rpi * 2._wp ) * SIN( rad * 23.5_wp )  )
+
+      ! day length in hours
+      strn(:,:) = 0.
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            zargu = TAN( zcodel ) * TAN( gphit(ji,jj) * rad )
+            zargu = MAX( -1., MIN(  1., zargu ) )
+            strn(ji,jj) = MAX( 0.0, 24. - 2. * ACOS( zargu ) / rad / 15. )
+         END DO
+      END DO
+      !
       IF( ln_timing )   CALL timing_stop('p4z_int')
       !
Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zlim.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zlim.F90	(revision 14275)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zlim.F90	(revision 14276)
@@ -63,4 +63,5 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xnanofer   !: Limitation of Fe uptake by nanophyto
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xdiatfer   !: Limitation of Fe uptake by diatoms
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xqfuncfecd, xqfuncfecn
 
    ! Coefficient for iron limitation following Flynn and Hipkin (1999)
@@ -90,27 +91,19 @@
       !
       INTEGER  ::   ji, jj, jk
-      REAL(wp) ::   zlim1, zlim2, zlim3, zlim4, zno3, zferlim, zcoef
+      REAL(wp) ::   zlim1, zlim2, zlim3, zlim4, zcoef
       REAL(wp) ::   z1_trbdia, z1_trbphy, ztem1, ztem2, zetot1, zetot2
-      REAL(wp) ::   zdenom, zratio, zironmin
+      REAL(wp) ::   zdenom, zratio, zironmin, zbactno3, zbactnh4
       REAL(wp) ::   zconc1d, zconc1dnh4, zconc0n, zconc0nnh4   
       REAL(wp) ::   fananof, fadiatf, znutlim, zfalim
+      REAL(wp) ::   znutlimtot, zlimno3, zlimnh4, zbiron
       !!---------------------------------------------------------------------
       !
       IF( ln_timing )   CALL timing_start('p4z_lim')
       !
-      sizena(:,:,:) = 0.0  ;  sizeda(:,:,:) = 0.0
+      sizena(:,:,:) = 1.0  ;  sizeda(:,:,:) = 1.0
       !
       DO jk = 1, jpkm1
          DO jj = 1, jpj
             DO ji = 1, jpi
-               
-               ! Tuning of the iron concentration to a minimum level that 
-               ! is set to the detection limit
-               ! --------------------------------------------------------
-               zno3    = trb(ji,jj,jk,jpno3) / 40.e-6
-               zferlim = MAX( 3e-11 * zno3 * zno3, 5e-12 )
-               zferlim = MIN( zferlim, 7e-11 )
-               trb(ji,jj,jk,jpfer) = MAX( trb(ji,jj,jk,jpfer), zferlim )
-
                ! Computation of a variable Ks of diatoms taking into account
                ! that increasing biomass is made of generally bigger cells
@@ -134,9 +127,10 @@
 
                ! Nanophytoplankton
-               znutlim = biron(ji,jj,jk) / concnfe(ji,jj,jk)
+               zbiron = ( 75.0 * ( 1.0 - plig(ji,jj,jk) ) + plig(ji,jj,jk) ) * biron(ji,jj,jk)
+               znutlim = zbiron / concnfe(ji,jj,jk)
                fananof = MAX(0.01, MIN(0.99, 1. / ( SQRT(znutlim) + 1.) ) )
 
                ! Diatoms
-               znutlim = biron(ji,jj,jk) / concdfe(ji,jj,jk)
+               znutlim = zbiron / concdfe(ji,jj,jk)
                fadiatf = MAX(0.01, MIN(0.99, 1. / ( SQRT(znutlim) + 1.) ) )
 
@@ -144,9 +138,11 @@
                ! heterotrophic bacteria
                ! -------------------------------------------------
-               zdenom = 1. /  ( concbno3 * concbnh4 + concbnh4 * trb(ji,jj,jk,jpno3) + concbno3 * trb(ji,jj,jk,jpnh4) )
-               xnanono3(ji,jj,jk) = trb(ji,jj,jk,jpno3) * concbnh4 * zdenom
-               xnanonh4(ji,jj,jk) = trb(ji,jj,jk,jpnh4) * concbno3 * zdenom
+               zlimnh4 = trb(ji,jj,jk,jpnh4) / ( concbno3 + trb(ji,jj,jk,jpnh4) )
+               zlimno3 = trb(ji,jj,jk,jpno3) / ( concbno3 + trb(ji,jj,jk,jpno3) )
+               znutlimtot = ( trb(ji,jj,jk,jpnh4) + trb(ji,jj,jk,jpno3) ) / ( concbno3 + trb(ji,jj,jk,jpnh4) + trb(ji,jj,jk,jpno3) )
+               zbactnh4 = znutlimtot * 5.0 * zlimnh4 / ( zlimno3 + 5.0 * zlimnh4 + rtrn )
+               zbactno3 = znutlimtot * zlimno3 / ( zlimno3 + 5.0 * zlimnh4 + rtrn )
                !
-               zlim1    = xnanono3(ji,jj,jk) + xnanonh4(ji,jj,jk)
+               zlim1    = zbactno3 + zbactnh4
                zlim2    = trb(ji,jj,jk,jppo4) / ( trb(ji,jj,jk,jppo4) + concbnh4 )
                zlim3    = trb(ji,jj,jk,jpfer) / ( concbfe + trb(ji,jj,jk,jpfer) )
@@ -166,10 +162,12 @@
                ! Limitation of Fe uptake (Quota formalism)
                zfalim = (1.-fananof) / fananof
-               xnanofer(ji,jj,jk) = (1. - fananof) * biron(ji,jj,jk) / ( biron(ji,jj,jk) + zfalim * concnfe(ji,jj,jk) )
+               xnanofer(ji,jj,jk) = (1. - fananof) * zbiron / ( zbiron + zfalim * concnfe(ji,jj,jk) )
 
                ! Limitation of nanophytoplankton growth
-               zdenom = 1. /  ( zconc0n * zconc0nnh4 + zconc0nnh4 * trb(ji,jj,jk,jpno3) + zconc0n * trb(ji,jj,jk,jpnh4) )
-               xnanono3(ji,jj,jk) = trb(ji,jj,jk,jpno3) * zconc0nnh4 * zdenom
-               xnanonh4(ji,jj,jk) = trb(ji,jj,jk,jpnh4) * zconc0n    * zdenom
+               zlimnh4 = trb(ji,jj,jk,jpnh4) / ( zconc0n + trb(ji,jj,jk,jpnh4) )
+               zlimno3 = trb(ji,jj,jk,jpno3) / ( zconc0n + trb(ji,jj,jk,jpno3) )
+               znutlimtot = ( trb(ji,jj,jk,jpnh4) + trb(ji,jj,jk,jpno3) ) / ( zconc0n + trb(ji,jj,jk,jpnh4) + trb(ji,jj,jk,jpno3) )
+               xnanonh4(ji,jj,jk) = znutlimtot * 5.0 * zlimnh4 / ( zlimno3 + 5.0 * zlimnh4 + rtrn )
+               xnanono3(ji,jj,jk) = znutlimtot * zlimno3 / ( zlimno3 + 5.0 * zlimnh4 + rtrn )
                !
                zlim1    = xnanono3(ji,jj,jk) + xnanonh4(ji,jj,jk)
@@ -181,4 +179,5 @@
                ! proposed by Flynn and Hipkin (1999)
                zironmin = xcoef1 * trb(ji,jj,jk,jpnch) * z1_trbphy + xcoef2 * zlim1 + xcoef3 * xnanono3(ji,jj,jk)
+               xqfuncfecn(ji,jj,jk) = zironmin + qnfelim
                zlim3    = MAX( 0.,( zratio - zironmin ) / qnfelim )
                xnanopo4(ji,jj,jk) = zlim2
@@ -190,10 +189,12 @@
                ! Limitation of Fe uptake (Quota formalism)
                zfalim = (1.-fadiatf) / fadiatf
-               xdiatfer(ji,jj,jk) = (1. - fadiatf) * biron(ji,jj,jk) / ( biron(ji,jj,jk) + zfalim * concdfe(ji,jj,jk) )
+               xdiatfer(ji,jj,jk) = (1. - fadiatf) * zbiron / ( zbiron + zfalim * concdfe(ji,jj,jk) )
 
                ! Limitation of diatoms growth
-               zdenom   = 1. / ( zconc1d * zconc1dnh4 + zconc1dnh4 * trb(ji,jj,jk,jpno3) + zconc1d * trb(ji,jj,jk,jpnh4) )
-               xdiatno3(ji,jj,jk) = trb(ji,jj,jk,jpno3) * zconc1dnh4 * zdenom
-               xdiatnh4(ji,jj,jk) = trb(ji,jj,jk,jpnh4) * zconc1d    * zdenom
+               zlimnh4 = trb(ji,jj,jk,jpnh4) / ( zconc1d + trb(ji,jj,jk,jpnh4) )
+               zlimno3 = trb(ji,jj,jk,jpno3) / ( zconc1d + trb(ji,jj,jk,jpno3) )
+               znutlimtot = ( trb(ji,jj,jk,jpnh4) + trb(ji,jj,jk,jpno3) ) / ( zconc1d + trb(ji,jj,jk,jpnh4) + trb(ji,jj,jk,jpno3) )
+               xdiatnh4(ji,jj,jk) = znutlimtot * 5.0 * zlimnh4 / ( zlimno3 + 5.0 * zlimnh4 + rtrn ) 
+               xdiatno3(ji,jj,jk) = znutlimtot * zlimno3 / ( zlimno3 + 5.0 * zlimnh4 + rtrn )
                !
                zlim1    = xdiatno3(ji,jj,jk) + xdiatnh4(ji,jj,jk)
@@ -206,4 +207,5 @@
                ! proposed by Flynn and Hipkin (1999)
                zironmin = xcoef1 * trb(ji,jj,jk,jpdch) * z1_trbdia + xcoef2 * zlim1 + xcoef3 * xdiatno3(ji,jj,jk)
+               xqfuncfecd(ji,jj,jk) = zironmin + qdfelim
                zlim4    = MAX( 0., ( zratio - zironmin ) / qdfelim )
                xdiatpo4(ji,jj,jk) = zlim2
@@ -238,12 +240,11 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zlim1 =  ( trb(ji,jj,jk,jpno3) * concnnh4 + trb(ji,jj,jk,jpnh4) * concnno3 )    &
-                  &   / ( concnno3 * concnnh4 + concnnh4 * trb(ji,jj,jk,jpno3) + concnno3 * trb(ji,jj,jk,jpnh4) ) 
+               zlim1  = xnanonh4(ji,jj,jk) + xnanono3(ji,jj,jk) 
                zlim2  = trb(ji,jj,jk,jppo4) / ( trb(ji,jj,jk,jppo4) + concnnh4 )
-               zlim3  = trb(ji,jj,jk,jpfer) / ( trb(ji,jj,jk,jpfer) +  5.E-11   )
-               ztem1  = MAX( 0., tsn(ji,jj,jk,jp_tem) )
+               zlim3  = trb(ji,jj,jk,jpfer) / ( trb(ji,jj,jk,jpfer) +  6.E-11   )
+               ztem1  = MAX( 0., tsn(ji,jj,jk,jp_tem) + 1.8)
                ztem2  = tsn(ji,jj,jk,jp_tem) - 10.
                zetot1 = MAX( 0., etot_ndcy(ji,jj,jk) - 1.) / ( 4. + etot_ndcy(ji,jj,jk) ) 
-               zetot2 = 30. / ( 30. + etot_ndcy(ji,jj,jk) ) 
+               zetot2 = 30. / ( 30.0 + etot_ndcy(ji,jj,jk) )
 
                xfracal(ji,jj,jk) = caco3r * MIN( zlim1, zlim2, zlim3 )                  &
@@ -375,4 +376,5 @@
          &      xlimbac (jpi,jpj,jpk), xlimbacl(jpi,jpj,jpk),       &
          &      concnfe (jpi,jpj,jpk), concdfe (jpi,jpj,jpk),       &
+         &      xqfuncfecn(jpi,jpj,jpk), xqfuncfecd(jpi,jpj,jpk),   &
          &      xlimsi  (jpi,jpj,jpk), STAT=p4z_lim_alloc )
       !
Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zlys.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zlys.F90	(revision 14275)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zlys.F90	(revision 14276)
@@ -57,5 +57,5 @@
       !
       INTEGER  ::   ji, jj, jk, jn
-      REAL(wp) ::   zdispot, zfact, zcalcon
+      REAL(wp) ::   zdispot, zfact, zcalcon, zkd
       REAL(wp) ::   zomegaca, zexcess, zexcess0
       CHARACTER (len=25) ::   charout
@@ -65,6 +65,6 @@
       IF( ln_timing )  CALL timing_start('p4z_lys')
       !
-      zco3    (:,:,:) = 0.
-      zcaldiss(:,:,:) = 0.
+      zco3    (:,:,:) = 0._wp
+      zcaldiss(:,:,:) = 0._wp     ;     zco3sat(:,:,:) = 0._wp
       zhinit  (:,:,:) = hi(:,:,:) * 1000. / ( rhop(:,:,:) + rtrn )
       !
@@ -106,8 +106,14 @@
                excess(ji,jj,jk) = 1._wp - zomegaca
                zexcess0 = MAX( 0., excess(ji,jj,jk) )
-               zexcess  = zexcess0**nca
+               IF (zomegaca < 0.8) THEN
+                  zexcess  = zexcess0**nca
+                 ! AMOUNT CACO3 THAT RE-ENTERS SOLUTION
+                  zdispot = kdca * zexcess * trb(ji,jj,jk,jpcal)
+               ELSE
+                  zkd = kdca * 0.1**(nca - 0.4)
+                  zexcess  = zexcess0**0.4
+                  zdispot = zkd * zexcess * trb(ji,jj,jk,jpcal)
+               ENDIF
 
-               ! AMOUNT CACO3 THAT RE-ENTERS SOLUTION
-               zdispot = kdca * zexcess * trb(ji,jj,jk,jpcal)
                ! CHANGE OF [CO3--] , [ALK], PARTICULATE [CACO3],
                ! AND [SUM(CO2)] DUE TO CACO3 DISSOLUTION/PRECIPITATION
